import renpy

class NamedTransform(object):
    # These are basically just keys that can be used to look up transforms in
    # the transforms_by_name dict
    def __init__(self, name, func):
        self.name = name
    def __call__(self,*args,**kwargs):
        return transforms_by_name[self.name](*args,**kwargs)
    def __repr__(self):
        try:
            ret = '<NamedTransform '+self.name+(' 0x%x'%id(self))+'>'
        except:
            return object.__repr__(self)
        return ret
    def __setstate__(self, state):
        pickleinspector.warn(("Debug: NamedTransform.__setstate__",state),0)
        self.name = state
    def __getstate__(self):
        return self.name

transforms_by_name = dict()
def build_named_transform_list(source):
    for name in dir(source):
        v = getattr(source,name)
        if type(v) is renpy.display.motion.ATLTransform:
            if v.varname is not None and v.varname!=name:
                print "Transform already has a name:",name,v.varname
                raise Exception("Error: multiname transform.")
            v.varname = name
            if name in transforms_by_name:
                raise Exception("There already is a transform by that name.")
            transforms_by_name[name] = v
            setattr(source, name, NamedTransform(name, v))

def init():
    build_named_transform_list(renpy.store)
